#include <sys/select.h>

int __pselect(int n, fd_set* readfds, fd_set* writefds, fd_set* exceptfds,
              const struct timespec *timeout, void* proxy);
int __libc_pselect(int n, fd_set* readfds, fd_set* writefds, fd_set* exceptfds,
                   const struct timespec *timeout, const sigset_t *sigmask) {
  struct {
    const sigset_t *sigmask;
    size_t nr;
  } proxy = {sigmask, _NSIG/8};

  return __pselect(n,readfds,writefds,exceptfds, timeout, &proxy);
}

int pselect(int n, fd_set* readfds, fd_set* writefds, fd_set* exceptfds,
            const struct timespec *timeout, const sigset_t *sigmask)
__attribute__((weak,alias("__libc_pselect")));
